<script setup lang="ts">
import type { BlogPage } from '@/types/blog';

interface categoryGroup {
  category: string;
  posts: BlogPage[];
}

defineProps<{
  groupedPosts: categoryGroup[];
}>();
</script>

<template>
  <SlpContainer>
    <div class="recent-posts">
      <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-32"> Browse by category </SlpTypography>
      <div class="cards">
        <div v-for="group in groupedPosts" :key="group.category" class="card">
          <a
            :href="`/blog/categories/${toKebabCase(group.category)}/`"
            :data-ga-name="group.category.toLowerCase()"
            data-ga-location="category-header"
          >
            <SlpTypography tag="span" variant="body1">
              {{ group.category }}
            </SlpTypography>
          </a>
          <a
            v-for="(post, index) in group.posts"
            :key="post.content.title"
            class="section"
            :href="post.config.externalUrl || `/blog/${post.config.slug}`"
            :data-ga-name="`${group.category.toLowerCase()} - ${post.content.title.toLowerCase()}`"
            data-ga-location="category-post"
          >
            <NuxtImg v-if="!index && post.content.heroImage" loading="lazy" :src="post.content.heroImage" alt="" />
            <SlpTypography v-if="post.content.title" variant="heading5-bold" tag="h3">{{
              post.content.title
            }}</SlpTypography>
            <SlpTypography v-if="!index && post.content.description" variant="body1" tag="p">
              {{ post.content.description }}
            </SlpTypography>
          </a>
        </div>
      </div>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.recent-posts {
  display: flex;
  flex-direction: column;
  gap: 16px;
  margin: 64px 0;
  .cards {
    display: grid;
    grid-template-columns: 1fr;
    gap: 30px;
    @media (min-width: $breakpoint-lg) {
      grid-template-columns: repeat(3, 1fr);
    }

    .card,
    .section {
      cursor: pointer;
      display: flex;
      flex-direction: column;
      align-items: flex-start;
      gap: 16px;
      color: $color-text-300;
    }
    .section {
      color: $color-text-300;
      padding-bottom: 16px;
      border-bottom: 1px solid $color-surface-200;
      img {
        width: 318px;
        min-height: 222px;
        height: 222px;
        object-fit: cover;
        @media (max-width: $breakpoint-lg) {
          max-width: 100%;
        }
      }
    }
    .card {
      padding: 16px;

      &:hover {
        background-color: #f6f3fe;
        transition:
          background 0.3s ease,
          border-radius 0.3s ease !important;
        border-radius: 8px 8px 50px 8px;
      }
    }
  }
}
</style>
